import java.util.*;

// Utility class to generate permutations of integer indices
public class PermutationGenerator {

	// Generate all permutations for given number of indices,
	// not really efficient for numbers > 8
	public Set generate(int number) {
	  Set permutations = new HashSet();
	  if (number == 1) {
		  Permutation p = new Permutation();
		  p.add(0);
		  permutations.add(p);
	  } else {
		  permutations = generate(number-1);
		  Set newPermutations = new HashSet();
		  for (int position = 0; position < number; position++) {
			  Iterator it = permutations.iterator();
			  while (it.hasNext()) {
				  Permutation p = (Permutation) it.next();
				  Permutation pn = new Permutation(p);
				  pn.insert(position, number-1);
				  newPermutations.add(pn);
			  }
		  }
		  permutations = newPermutations;
	  }
	  return permutations;
	}
}
